
package de.ivu.elect.presentation.kandidatur.action;

import de.ivu.elect.business.kandidatur.entity.KandidaturStatus;
import de.ivu.elect.business.kandidatur.entity.Listenkandidatur;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.wahl.CurrentWahlZulassungspruefungExtended;

import javax.inject.Named;

@Named(ListenkandidaturZulassungZuruecksetzenAction.COMPONENT_NAME)
public class ListenkandidaturZulassungZuruecksetzenAction extends AbstractListenkandidaturZulassungAction {

  public static final String COMPONENT_NAME = "listenkandidaturZulassungZuruecksetzenAction";

  private static final long serialVersionUID = 1L;

  public ListenkandidaturZulassungZuruecksetzenAction() {
    super();
  }

  @Override
  protected UseCasePermission getRequiredPermission() {
    return UseCasePermission.WAHLVORSCHLAG_QS_ZULASSUNG_ZURUECKSETZEN;
  }

  @Override
  public boolean isDisabledInternal(Listenkandidatur listenkandidatur, CurrentWahlZulassungspruefungExtended currentWahlZulassungspruefung) {
    return !currentWahlZulassungspruefung.isZulassungZuruecksetzenZulaessig(listenkandidatur);
  }

  @Override
  protected KandidaturStatus getKandidaturStatus() {
    return KandidaturStatus.OFFEN;
  }

  @Override
  public String getLabelKey() {
    return "listenkandidatur.search.action.status.ungeprueft.setzen";
  }
}
